// helper functions
function $(id){
  return document.getElementById(id);
}

function rjust(s,l) {
  s = String(s);
  var n = l - s.length;
  for (var i=0; i<n; i++) {
    s = "0" + s;
  }
  return s;
}

function monthLength(date) {
  var d=  new Date(date);
  return new Date(new Date(d.setMonth(d.getMonth()+1)).setDate(0)).getDate();
}

  //extend Array prototype to remove certain values
Array.prototype.clean = function(deleteValue) {
  for (var i=0; i<this.length; i++) {
    if (this[i] == deleteValue) {
      this.splice(i, 1);
      i--;
    }
  }
  return this;
};

// global variables
drag = false;
spin = null;
selectedDate = "";
begin = new Date();
end = new Date();
t0 = "";
t1 = "";
monthStrings = ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"];

function drawScale(b, e) {
  b += "2000-01-01T00:00".slice(b.length);
  begin = new Date(b.replace(/-/, "/"));
  e += "2000-12-31T23:59".slice(e.length);
  end = new Date(e.replace(/-/, "/"));
  var diff = (end - begin) / 60000;
  var t0 = "";
  var t1 = "";
  if (diff < 500) { // min 1440
    begin = new Date(begin.getFullYear(), begin.getMonth(), begin.getDate(), begin.getHours(), 5 * Math.floor(begin.getMinutes() / 5));
    end = new Date(end.getFullYear(), end.getMonth(), end.getDate(), end.getHours(), end.getMinutes());
    t1 += "<td colspan='" + (12 - Math.floor(begin.getMinutes() / 5)) + "'><div>" + begin.getHours() + "</div></td>";
    for (var d = new Date(begin); d < end) {
      var min = d.getMinutes();
      var qhour = (min == 0 || min == 15 || min == 30 || min == 45) ? min : "";
      t0 += "<td><div>" + qhour + "</div></td>";
      d.setMinutes(d.getMinutes() + 5);
      if (d.getMinutes() == 0 && d < end) {
        t1 += "<td colspan='12'><div>" + d.getHours() + "</div></td>";
      }
    }
  } else if (diff < 4000) { // h 43829
    begin = new Date(begin.getFullYear(), begin.getMonth(), begin.getDate(), begin.getHours());
    end = new Date(end.getFullYear(), end.getMonth(), end.getDate(), end.getHours());
    t1 += "<td colspan='" + (24 - begin.getHours()) + "'><div>" + begin.getDate() + "</div></td>";
    for (var d = new Date(begin); d < end;) {
      t0 += "<td><div>" + d.getHours() + "</div></td>";
      d.setHours(d.getHours() + 1);
      if (d.getHours() == 0 && d < end) t1 += "<td colspan='24'><div>" + d.getDate() + "</div></td>";
    }
  } else if (diff < 25000) { // h 43829
    begin = new Date(begin.getFullYear(), begin.getMonth(), begin.getDate(), 3 * Math.floor(begin.getHours() / 3));
    end = new Date(end.getFullYear(), end.getMonth(), end.getDate(), end.getHours());
    t1 += "<td colspan='" + (8 - Math.floor(begin.getHours() / 3)) + "'><div>" + begin.getDate() + "</div></td>";
    for (var d = new Date(begin); d < end;) {
      t0 += "<td><div>" + d.getHours() + "</div></td>";
      d.setHours(d.getHours() + 3);
      if (d.getHours() == 0 && d < end) t1 += "<td colspan='8'><div>" + d.getDate() + "</div></td>";
    }
  } else if (diff < 150000) { // d 525946
    begin = new Date(begin.getFullYear(), begin.getMonth(), begin.getDate());
    end = new Date(end.getFullYear(), end.getMonth(), end.getDate() + 1);
    t1 += "<td colspan='" + (monthLength(begin) - begin.getDate() + 1) + "'><div>" + monthStrings[begin.getMonth()] + "</div></td>";
    for (var d = new Date(begin); d <= end;) {
      t0 += "<td><div>" + d.getDate() + "</div></td>";
      d.setDate(d.getDate() + 1);
      if (d.getDate() == 1 && d < end) t1 += "<td colspan='" + monthLength(d) + "'><div>" + monthStrings[d.getMonth()] + "</div></td>";
    }
  } else if (diff < 4000000) { // month 5259460
    begin = new Date(begin.getFullYear(), begin.getMonth(), 1);
    end = new Date(end.getFullYear(), end.getMonth() + 1, 1);
    t1 += "<td colspan='" + (12 - begin.getMonth()) + "'><div>" + begin.getFullYear() + "</div></td>";
    for (var d = new Date(begin); d < end;) {
      t0 += "<td><div>" + monthStrings[d.getMonth()] + "</div></td>";
      d.setMonth(d.getMonth() + 1);
      if (d.getMonth() == 0 && d < end) t1 += "<td colspan='12'><div>" + d.getFullYear() + "</div></td>";
    }
  } else if (diff < 52594600) { // year
    begin = new Date(begin.getFullYear(), 0, 1);
    end = new Date(end.getFullYear() + 1, 0, 1);
    t1 += "<td colspan='" + (10 - begin.getFullYear() % 10) + "'><div>" + begin.getFullYear() + "</div></td>";
    for (var d = new Date(begin); d < end;) {
      var y = (d.getFullYear() % 100);
      y = (y != 0) ? rjust(y, 2) : "";
      t0 += "<td colspan='1'><div>" + y + "</div></td>";
      d.setYear(d.getFullYear() + 1);
      if (d.getFullYear() % 10 == 0 && d < end) t1 += "<td colspan='10'><div>" + d.getFullYear() + "</div></td>";
    }
  } else { // decade
    begin = new Date(10 * Math.floor(begin.getFullYear() / 10), 0, 1);
    end = new Date(10 * Math.ceil(end.getFullYear() / 10), 0, 1);
    t1 += "<td colspan='" + (10 - Math.floor(begin.getFullYear() / 10) % 10) + "'><div>" + begin.getFullYear() + "</div></td>";
    for (var d = new Date(begin); d < end;) {
      var y = (d.getFullYear() % 100);
      y = (y != 0) ? rjust(y, 2) : "";
      t0 += "<td colspan='1'><div>" + y + "</div></td>";
      d.setYear(d.getFullYear() + 10);
      if (d.getFullYear() % 100 == 0 && d < end) t1 += "<td colspan='10'><div>" + d.getFullYear() + "</div></td>";
    }
  }
  $("scale").innerHTML = "<table class='scale'><tbody><tr>" + t0 + "</tr><tr>" + t1 + "</tr></tbody></table>"
  var s = new Date(Number(begin) + (0.5) * (Number(end) - Number(begin)));
  selectedDate = rjust(s.getFullYear(), 4) + "-" + rjust(s.getMonth() + 1, 2) + "-" + rjust(s.getDate(), 2) + "T" + rjust(s.getHours(), 2) + ":" + rjust(s.getMinutes(), 2);
  reportDate();
}

function moveGripper(left) {
  var w = $("timeline-bar").offsetWidth
  var l = left - $("timeline-gadget").offsetLeft - $("timeline-bar").offsetLeft - 0.5 * w;
  l = 100 * l / w;
  if (l < -50) l = -50;
  if (l > 50) l = 50;
  $("gripper").style.marginLeft = l + "%";
  var s = new Date(Number(begin) + (0.5 + l / 100) * (Number(end) - Number(begin)));
  selectedDate = rjust(s.getFullYear(), 4) + "-" + rjust(s.getMonth() + 1, 2) + "-" + rjust(s.getDate(), 2) + "T" + rjust(s.getHours(), 2) + ":" + rjust(s.getMinutes(), 2);
}

// callback

function reportDate() {
  if (selectedDate != "") {
    AE.Bridge.callRuby("change_time", selectedDate);
  }

  function scrollGripper(delta) {
    var gripperLeft = $("timeline-gadget").offsetLeft + $("gripper").offsetLeft + 2;
    moveGripper(gripperLeft + 2 * delta);
  }

  function wheel(event) {
    var delta = 0;
    if (!event) /* For IE. */
      event = window.event;
    if (event.wheelDelta) { /* IE/Opera. */
      delta = event.wheelDelta / 120;
    } else if (event.detail) { /** Mozilla case. */
      delta = -event.detail / 3;
    }
    if (delta) scrollGripper(delta);
    if (event.preventDefault) event.preventDefault();
    event.returnValue = false;
  }

  function init(b, e) {
    drawScale(b, e);
    $("gripper").onmousedown = function () {
      drag = true;
      spin = window.setInterval("reportDate()", 50)
    };
    document.onmousemove = function (event) {
      if (drag == true) {
        if (!event) event = window.event;
        moveGripper(event.clientX)
      }
    }
    document.onmouseup = function () {
      drag = false;
      if (spin != null) window.clearInterval(spin);
      reportDate()
    };
    var elem = $("timeline-gadget");
    if (elem.addEventListener) {
      elem.addEventListener("mousewheel", wheel, false);
      elem.addEventListener("DOMMouseScroll", wheel, false);
    } else {
      if (elem.attachEvent) elem.attachEvent("onmousewheel", wheel);
    }
  }
